#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SIZE(x) (int)(sizeof(x) / sizeof(x[0]))

unsigned char dst[65536];

unsigned char trnsinit[] = {
	0xF3,			//	DI
	0x21, 0x00, 0x00	//	LD	HL, xxxx
};
unsigned char trns0000[] = {
	0x11, 0x00, 0x00,	//	LD	DE, 0000h
	0x01, 0x00, 0x00,	//	LD	BC, xxxx
	0xD3, 0xE0,		//	OUT	(0E0h), A
	0xED, 0xB0		//	LDIR
};
unsigned char trnsD000[] = {
	0x11, 0x00, 0xD0,	//	LD	DE, 0D000h
	0x01, 0x00, 0x00,	//	LD	BC, xxxx
	0xD3, 0xE1,		//	OUT	(0E1h), A
	0xED, 0xB0		//	LDIR
};
unsigned char trns1200[] = {
	0x11, 0x00, 0xDE,	//	LD	DE, 0DE00h
	0x01, 0x00, 0x00,	//	LD	BC, xxxx
	0xD3, 0xE3,		//	OUT	(0E3h), A
	0xED, 0xB0		//	LDIR
};
unsigned char trnstini[] = {
	0xD3, 0xE4,		//	OUT	(0E4h), A
	0x21, 0x00, 0x00,	//	LD	HL, trnsend
	0x11, 0x00, 0xDD,	//	LD	DE, 0DD00h
	0x01, 0x10, 0x00,	//	LD	BC, SIZE(trnsend)
	0xED, 0xB0,		//	LDIR
	0xCD, 0x27, 0x00,	//	CALL	?RDI
	0xDA, 0xFE, 0x00,	//	JP	C, ?ER
	0xC3, 0x18, 0x01	//	JP	0118h		; to 1Z-009A 'L' command
};
unsigned char trnsend[] = {
	0x21, 0x00, 0xDE,	//	LD	HL, 0DE00h
	0x11, 0x00, 0x10,	//	LD	DE,  1000h
	0x01, 0x00, 0x02,	//	LD	BC,   200h
	0xED, 0xB0,		//	LDIR
	0xD3, 0xE0,		//	OUT	(0E0h), A
	0xC3, 0x00, 0x00	//	JP	xxxx		; to exec addres
};

char *copyfn(char *fn, char suffix) {
	static char buf[512];
	int l;
	strcpy(buf, fn);
	l = strlen(buf);
	if (l > 4 && !strcmpi(&buf[l-4], ".MZT")) {
		strcpy(&buf[l-4], "0.MZT");
		buf[l-4] = suffix;
	}
	return buf;
}

int addcodes(unsigned char *s, int siz, int idx, unsigned char opc, int opr) {
	unsigned char c;
	int i;
	for (i=0; i<siz; i++) {
		c = *s++;
		if (opc && c == opc && s[0] == 0x00 && s[1] == 0x00) {
			dst[idx++] = c;
			dst[idx++] = (unsigned char)(opr & 0x00ff);
			dst[idx++] = (unsigned char)((opr & 0xff00)>>8);
			s += 2;
			i += 2;
		} else {
			dst[idx++] = c;
		}
	}
	return idx;
}

int main(int argc, char *argv[]) {

	int startaddr, execaddr, filesize, endaddr;
	int s, s12, sD0;
	int e, e00, e12, eD0;
	int siz00, siz12, sizD0;
	int idx;
	int i, j;
	long siz, l;
	unsigned char *src;
	FILE *fpr, *fpw;

	if (argc < 2) {
		printf("Usage: splitmzt [MZT filename]\n");
		return 0;
	}

	fpr = fopen(argv[1], "rb");
	if (fpr == NULL) {
		fprintf(stderr, "%s܂\n", argv[1]);
		return 0;
	}
	fseek(fpr, 0L, SEEK_END);
	siz = ftell(fpr);
	src = (unsigned char *)malloc(siz);
	if (src == NULL) {
		fprintf(stderr, "܂\n");
		fclose(fpr);
		return 0;
	}
	fseek(fpr, 0L, SEEK_SET);
	l = fread(src, 1, siz, fpr);
	if (l != siz) {
		fprintf(stderr, "%s̓ǂݍ݂Ɏs܂\n", argv[1]);
		fclose(fpr);
		free(src);
		return 0;
	}
	fclose(fpr);


	/* check MZT header */

	filesize  = (int)src[0x12] | ((int)src[0x13] << 8);
	startaddr = (int)src[0x14] | ((int)src[0x15] << 8);
	execaddr  = (int)src[0x16] | ((int)src[0x17] << 8);
	if (filesize == 0) filesize = 0x10000;
	endaddr = startaddr + filesize;

	/* create 1st MZT */

	idx = 0x1200 + SIZE(trnsinit);
	siz00 = siz12 = sizD0 = 0;

	if (startaddr < 0x1000) {
		e00 = (endaddr > 0x1000) ? 0x1000 : endaddr;
		siz00 = e00 - startaddr;
		trns0000[1] = (unsigned char)( startaddr & 0x00FF );
		trns0000[2] = (unsigned char)((startaddr & 0xFF00) >> 8);
		idx = addcodes(trns0000, SIZE(trns0000), idx, 0x01, siz00);
	}

	if (endaddr > 0x1000 && startaddr < 0x1200) {
		s12 = (startaddr < 0x1000) ? 0x1000 : startaddr;
		e12 = (endaddr   > 0x1200) ? 0x1200 : endaddr;
		siz12 = e12 - s12;
		idx = addcodes(trns1200, SIZE(trns1200), idx, 0x01, siz12);
	}

	if (endaddr > 0xD000 && startaddr < 0x10000) {
		sD0 = (startaddr < 0xD000) ? 0xD000 : startaddr;
		eD0 = (endaddr  > 0x10000) ? 0x10000 : endaddr;
		sizD0 = eD0 - sD0;
		idx = addcodes(trnsD000, SIZE(trnsD000), idx, 0x01, sizD0);
	}

	i   = addcodes(trnstini, SIZE(trnstini), idx, 0x00, 0);
	idx = addcodes(trnstini, SIZE(trnstini), idx, 0x21, i);
	idx = addcodes(trnsend , SIZE(trnsend),  idx, 0xC3, execaddr);
	addcodes(trnsinit, SIZE(trnsinit), 0x1200, 0x21, idx);

	j = 128;
	for (i=0; i<siz00; i++) dst[idx++] = src[j++];

	j = 128 + (s12 - startaddr);
	for (i=0; i<siz12; i++) dst[idx++] = src[j++];

	j = 128 + (sD0 - startaddr);
	for (i=0; i<sizD0; i++) dst[idx++] = src[j++];


	/* write 1st MZT */

	siz = idx - 0x1200;
	src[0x12] = (unsigned char)( siz & 0x00FF);
	src[0x13] = (unsigned char)((siz & 0xFF00) >> 8);
	src[0x14] = (unsigned char)0x00;
	src[0x15] = (unsigned char)0x12;
	src[0x16] = (unsigned char)0x00;
	src[0x17] = (unsigned char)0x12;
	fpw = fopen(copyfn(argv[1], '1'), "wb");
	fwrite(src, 1, 128, fpw);
	fwrite(&dst[0x1200], 1, siz, fpw);
	fclose(fpw);


	/* write 2nd MZT */

	s = (startaddr < 0x1200) ? 0x1200 : startaddr;
	e = (endaddr   > 0xD000) ? 0xD000 : endaddr;
	siz = e - s;
	src[0x12] = (unsigned char)( siz & 0x00FF);
	src[0x13] = (unsigned char)((siz & 0xFF00) >> 8);
	src[0x14] = (unsigned char)( s & 0x00FF);
	src[0x15] = (unsigned char)((s & 0xFF00) >> 8);
	src[0x16] = (unsigned char)0x00;
	src[0x17] = (unsigned char)0xDD;
	fpw = fopen(copyfn(argv[1], '2'), "wb");
	fwrite(src, 1, 128, fpw);
	fwrite(&src[128 + (s - startaddr)], 1, siz, fpw);
	fclose(fpw);

	free(src);
	return 0;
}
